/*
 * Copyright (C) 2022 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#define TLOG_TAG "hwaes_bench"
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include <lib/hwaes/hwaes.h>
#include <lib/hwkey/hwkey.h>
#include <sys/auxv.h>
#include <sys/mman.h>
#include <trusty/memref.h>
#include <trusty_benchmark.h>
#include <trusty_unittest.h>
#include <uapi/err.h>

/**
 * Helper Macros
 */
#define HWAES_MAX_NUM_HANDLES 8
#define PAGE_SIZE() getauxval(AT_PAGESZ)
#define CHECK(exec)       \
    rc = exec;            \
    if (rc != NO_ERROR) { \
        return rc;        \
    }

#define INPUT_BYTES_ENCRYPT(...) plaintext
#define INPUT_BYTES_DECRYPT(mode, key_size, input_size) \
    ciphertext_##mode##_##key_size##_##input_size

#define INPUT_BYTES(mode, key_size, input_size, direction) \
    INPUT_BYTES##_##direction(mode, key_size, input_size)

#define OUTPUT_BYTES_ENCRYPT(mode, key_size, input_size) \
    ciphertext_##mode##_##key_size##_##input_size
#define OUTPUT_BYTES_DECRYPT(...) plaintext

#define OUTPUT_BYTES(mode, key_size, input_size, direction) \
    OUTPUT_BYTES##_##direction(mode, key_size, input_size)

#define DIRECTION_ENCRYPT 1
#define DIRECTION_DECRYPT 0

#define TAG(key_size, input_size) tag_##key_size##_##input_size

#define GCM_TAG_LEN 16
#define HWAES_CRYPT_ARGS(arg_mode, arg_key_size, arg_input_size,               \
                         arg_direction)                                        \
    {                                                                          \
        .key = key_##arg_key_size, .key_size = sizeof(key_##arg_key_size),     \
        .input = INPUT_BYTES(arg_mode, arg_key_size, arg_input_size,           \
                             arg_direction),                                   \
        .input_size = arg_input_size / 8,                                      \
        .output = OUTPUT_BYTES(arg_mode, arg_key_size, arg_input_size,         \
                               arg_direction),                                 \
        .output_size = sizeof(OUTPUT_BYTES(arg_mode, arg_key_size,             \
                                           arg_input_size, arg_direction)),    \
        .iv = iv_##arg_mode, .iv_size = sizeof(iv_##arg_mode),                 \
        .tag = TAG(arg_key_size, arg_input_size), .tag_size = GCM_TAG_LEN,     \
        .mode = HWAES_##arg_mode##_MODE, .encrypt = DIRECTION_##arg_direction, \
    }

#define CUR_PARAM params[bench_get_param_idx()]

/**
 * struct hwaes_iov - a wrapper of an array of iovec.
 * @iovs: array of iovec.
 * @num_iov: number of iovec.
 * @total_len: total length of the tipc message.
 */
struct hwaes_iov {
    struct iovec iov[TIPC_MAX_MSG_PARTS];
    size_t num_iov;
    size_t total_len;
};

/**
 * struct hwaes_shm - a wrapper of an array of shared memory handles.
 * @handles:     array of shared memory handles.
 * @num_handles: number of shared memory handles.
 */
struct hwaes_shm {
    handle_t handles[HWAES_MAX_NUM_HANDLES];
    size_t num_handles;
};

/* Keys */
static const uint8_t key_128[16] = {0x00};
static const uint8_t key_256[32] = {0x00};

/* IV */
static const uint8_t iv_CBC[16] = {0x00};
static const uint8_t iv_GCM[12] = {0x00};

/* Tags and aad */
static const uint8_t aad[16] = {0x00};
static const uint8_t tag_128_256[] = {0x39, 0x69, 0x1D, 0x1A, 0xB7, 0x0A,
                                      0x22, 0x08, 0x4A, 0xE9, 0x33, 0x7C,
                                      0x69, 0x7C, 0x3B, 0xEE};

static const uint8_t tag_128_4096[] = {0xDE, 0xDD, 0x00, 0x3C, 0x3F, 0x80,
                                       0xF9, 0x81, 0x47, 0x16, 0x08, 0x3B,
                                       0x66, 0x41, 0xCA, 0xFB};

static const uint8_t tag_256_256[] = {0xAF, 0x99, 0xD7, 0x9A, 0xDB, 0x9A,
                                      0x2E, 0x0D, 0x4F, 0x7B, 0x46, 0x21,
                                      0xAB, 0xA1, 0x48, 0xF0};

static const uint8_t tag_256_4096[] = {0x47, 0xC6, 0x12, 0xE1, 0x67, 0xDD,
                                       0x2B, 0xE5, 0xDD, 0x15, 0xD7, 0x64,
                                       0x16, 0x43, 0xAA, 0x13};

/* PlainText */
static const uint8_t plaintext[4096] = {0x00};

/* CipherTexts */
static const uint8_t ciphertext_CBC_128_256[] = {
        0x66, 0xE9, 0x4B, 0xD4, 0xEF, 0x8A, 0x2C, 0x3B, 0x88, 0x4C, 0xFA,
        0x59, 0xCA, 0x34, 0x2B, 0x2E, 0xF7, 0x95, 0xBD, 0x4A, 0x52, 0xE2,
        0x9E, 0xD7, 0x13, 0xD3, 0x13, 0xFA, 0x20, 0xE9, 0x8D, 0xBC};
static const uint8_t ciphertext_CBC_256_256[] = {
        0xDC, 0x95, 0xC0, 0x78, 0xA2, 0x40, 0x89, 0x89, 0xAD, 0x48, 0xA2,
        0x14, 0x92, 0x84, 0x20, 0x87, 0x08, 0xC3, 0x74, 0x84, 0x8C, 0x22,
        0x82, 0x33, 0xC2, 0xB3, 0x4F, 0x33, 0x2B, 0xD2, 0xE9, 0xD3};
static const uint8_t ciphertext_CBC_128_4096[] = {
        0x66, 0xE9, 0x4B, 0xD4, 0xEF, 0x8A, 0x2C, 0x3B, 0x88, 0x4C, 0xFA, 0x59,
        0xCA, 0x34, 0x2B, 0x2E, 0xF7, 0x95, 0xBD, 0x4A, 0x52, 0xE2, 0x9E, 0xD7,
        0x13, 0xD3, 0x13, 0xFA, 0x20, 0xE9, 0x8D, 0xBC, 0xA1, 0x0C, 0xF6, 0x6D,
        0x0F, 0xDD, 0xF3, 0x40, 0x53, 0x70, 0xB4, 0xBF, 0x8D, 0xF5, 0xBF, 0xB3,
        0x47, 0xC7, 0x83, 0x95, 0xE0, 0xD8, 0xAE, 0x21, 0x94, 0xDA, 0x0A, 0x90,
        0xAB, 0xC9, 0x88, 0x8A, 0x94, 0xEE, 0x48, 0xF6, 0xC7, 0x8F, 0xCD, 0x51,
        0x8A, 0x94, 0x1C, 0x38, 0x96, 0x10, 0x2C, 0xB1, 0x14, 0xF8, 0x4F, 0x5E,
        0x03, 0x15, 0xA2, 0x4C, 0xA4, 0xC0, 0x5F, 0x6E, 0x92, 0xDB, 0xDD, 0x25,
        0xA7, 0x08, 0x7A, 0xE9, 0x47, 0x35, 0xE1, 0xF8, 0x3C, 0x08, 0x1C, 0x59,
        0x20, 0xFB, 0x98, 0x17, 0x35, 0x42, 0x8E, 0x2B, 0x26, 0x7F, 0xB5, 0x99,
        0xF7, 0x4D, 0xF4, 0x15, 0xCF, 0x6F, 0xD1, 0x2E, 0xA2, 0x06, 0x26, 0x26,
        0xAC, 0xDC, 0xE7, 0xCF, 0x47, 0x68, 0x24, 0x0E, 0xFA, 0x40, 0x44, 0x83,
        0x07, 0xE1, 0xF4, 0x5D, 0x53, 0x47, 0xA0, 0xFE, 0xC0, 0x6E, 0x4E, 0xF8,
        0x9D, 0x98, 0x63, 0xB8, 0x2C, 0x27, 0xFA, 0x3A, 0xD5, 0x40, 0xDA, 0xDB,
        0xE6, 0xC3, 0xE4, 0xFB, 0x85, 0x53, 0xFB, 0x78, 0x5D, 0xBD, 0x8F, 0x4C,
        0x1A, 0x04, 0x9C, 0x88, 0x85, 0xEC, 0x3C, 0x56, 0x46, 0x1A, 0x6E, 0xF5,
        0x25, 0x72, 0xC5, 0xFD, 0x84, 0x76, 0x4C, 0xE9, 0x98, 0x6D, 0x35, 0x82,
        0xC3, 0x6B, 0x64, 0x24, 0xBF, 0xA9, 0xC4, 0xAA, 0x3A, 0xBE, 0xAB, 0x8E,
        0x3D, 0x59, 0x24, 0x8D, 0xD6, 0xB5, 0x63, 0x4B, 0x2D, 0x4E, 0x76, 0x95,
        0xA8, 0x45, 0x73, 0x82, 0xD0, 0xB0, 0xCE, 0x40, 0x2A, 0x75, 0xCA, 0x1A,
        0x3D, 0x9C, 0xBD, 0xD2, 0x34, 0x3A, 0xF3, 0xBD, 0x89, 0x38, 0xFC, 0xD4,
        0x00, 0x47, 0xB9, 0x2F, 0xFA, 0x95, 0x30, 0x4E, 0x91, 0x58, 0xB6, 0xEA,
        0x8B, 0x21, 0xBB, 0xAF, 0xA3, 0xE5, 0x54, 0xCF, 0x20, 0x75, 0x68, 0x6D,
        0xDB, 0x2A, 0xB2, 0x76, 0x2C, 0xD8, 0x1E, 0x99, 0x85, 0x45, 0x2F, 0x00,
        0x67, 0x0D, 0xDE, 0x42, 0xDA, 0x8A, 0x38, 0xC3, 0xEF, 0xD7, 0x57, 0x75,
        0xA0, 0x65, 0x4B, 0xF4, 0x4B, 0x52, 0x12, 0xFC, 0x9B, 0x81, 0xEA, 0xA6,
        0x2C, 0x26, 0xC1, 0xBB, 0x32, 0x57, 0x8C, 0x72, 0x77, 0x64, 0x0A, 0x88,
        0x56, 0xA2, 0xEE, 0xBE, 0x29, 0x9A, 0x56, 0x0A, 0xEC, 0x9B, 0x42, 0x9C,
        0x90, 0xF8, 0xBD, 0xB5, 0x23, 0x24, 0x3F, 0x49, 0xEF, 0x31, 0xC6, 0x34,
        0xEB, 0xA9, 0x86, 0x0A, 0x07, 0x50, 0xF6, 0xEF, 0x79, 0xE5, 0xFD, 0x21,
        0xCF, 0x34, 0xEF, 0x8F, 0x46, 0x6E, 0x75, 0xCD, 0xF8, 0xC3, 0xF4, 0x1F,
        0x28, 0x30, 0x4C, 0xA9, 0x21, 0x9C, 0x56, 0x86, 0x3E, 0x65, 0x20, 0xF2,
        0xF9, 0x14, 0x90, 0x1C, 0x17, 0x4C, 0x3D, 0x98, 0xDA, 0xC4, 0x0C, 0x0A,
        0xAE, 0x2F, 0xA3, 0x1B, 0xEA, 0x79, 0x7B, 0x45, 0xCC, 0x12, 0x8E, 0xAB,
        0xE9, 0x9E, 0xB5, 0x51, 0x97, 0xA2, 0x0F, 0x7C, 0xA8, 0x3B, 0xF4, 0xEF,
        0x15, 0xCD, 0x89, 0xC0, 0xBA, 0x38, 0xAA, 0x7A, 0xD7, 0x38, 0xA9, 0x33,
        0x6F, 0xFE, 0x92, 0x15, 0xBD, 0xF0, 0x60, 0xA9, 0xE8, 0xF9, 0x98, 0xE0,
        0x53, 0x61, 0x9A, 0x11, 0xB2, 0xAC, 0x86, 0x29, 0x5E, 0x34, 0xAB, 0x2E,
        0x0B, 0xB9, 0x9B, 0xF1, 0xBA, 0x63, 0x8A, 0xD5, 0xD2, 0x59, 0x12, 0xB6,
        0x7B, 0x2B, 0xED, 0x35, 0x25, 0xD4, 0x3F, 0x74, 0x87, 0xE1, 0x4A, 0x34,
        0xFB, 0xF7, 0xDA, 0x0B, 0xF3, 0x98, 0xE1, 0x50, 0xA2, 0x8B, 0x2A, 0x2C,
        0x2C, 0xC2, 0x83, 0x54, 0x07, 0x6A, 0xB6, 0xE0, 0x95, 0x0B, 0x2B, 0xB3,
        0xD6, 0xD3, 0x5D, 0x4F, 0xCC, 0x2F, 0xAF, 0x6A};
static const uint8_t ciphertext_CBC_256_4096[] = {
        0xDC, 0x95, 0xC0, 0x78, 0xA2, 0x40, 0x89, 0x89, 0xAD, 0x48, 0xA2, 0x14,
        0x92, 0x84, 0x20, 0x87, 0x08, 0xC3, 0x74, 0x84, 0x8C, 0x22, 0x82, 0x33,
        0xC2, 0xB3, 0x4F, 0x33, 0x2B, 0xD2, 0xE9, 0xD3, 0x8B, 0x70, 0xC5, 0x15,
        0xA6, 0x66, 0x3D, 0x38, 0xCD, 0xB8, 0xE6, 0x53, 0x2B, 0x26, 0x64, 0x91,
        0x5D, 0x0D, 0xCC, 0x19, 0x25, 0x80, 0xAE, 0xE9, 0xEF, 0x8A, 0x85, 0x68,
        0x19, 0x3F, 0x1B, 0x44, 0xBF, 0xCA, 0x55, 0x7C, 0x6B, 0xAB, 0x7D, 0xC7,
        0x9D, 0xA0, 0x7F, 0xFD, 0x42, 0x19, 0x1B, 0x26, 0x3F, 0xEA, 0x78, 0xD1,
        0x1C, 0xD6, 0xC9, 0x32, 0xB7, 0x9B, 0xBC, 0xF4, 0x34, 0x3C, 0x85, 0x16,
        0x0E, 0x9C, 0xA5, 0x0D, 0x25, 0x01, 0x70, 0x45, 0x70, 0x0D, 0xF9, 0x35,
        0xE0, 0x4A, 0xDA, 0x66, 0xFB, 0x0D, 0xF0, 0x3A, 0x1C, 0x8E, 0x33, 0xBA,
        0x41, 0x9F, 0x76, 0xBA, 0x5C, 0x54, 0x99, 0x0F, 0x53, 0x72, 0x01, 0x2F,
        0xB9, 0x08, 0xEB, 0x45, 0x4F, 0x16, 0x8E, 0x3C, 0xDF, 0x4B, 0x6F, 0x19,
        0x5F, 0x65, 0xE9, 0xBC, 0x8D, 0x72, 0x20, 0x40, 0x63, 0xE8, 0xD1, 0x9D,
        0x6C, 0x2F, 0x07, 0x7B, 0x65, 0xE4, 0x06, 0xAA, 0x8C, 0x3B, 0x83, 0xD2,
        0x6B, 0x03, 0xB3, 0xC3, 0xFA, 0xD4, 0xA0, 0xE2, 0x06, 0xC8, 0xF3, 0x8A,
        0x28, 0xB5, 0xDC, 0xBC, 0xE1, 0x3D, 0x84, 0x26, 0x88, 0xB8, 0x4C, 0x25,
        0x97, 0xAC, 0x2F, 0x60, 0x07, 0x2E, 0x6D, 0xFF, 0x8E, 0x1E, 0x77, 0xEB,
        0xB6, 0xA2, 0xF2, 0x90, 0x98, 0x66, 0x74, 0x6A, 0x71, 0x71, 0x98, 0xD9,
        0xB4, 0xC5, 0x0D, 0xB4, 0xE0, 0x19, 0x9D, 0x40, 0x69, 0x95, 0xBE, 0x84,
        0x55, 0x1A, 0xE3, 0xCE, 0x5D, 0x02, 0x1F, 0x3F, 0xAD, 0x70, 0x83, 0x41,
        0xD1, 0xD7, 0x40, 0x02, 0xDF, 0x38, 0xC5, 0x86, 0x36, 0xFC, 0x82, 0xF1,
        0xF3, 0x89, 0x22, 0xFC, 0x29, 0xE5, 0x09, 0x31, 0x6B, 0xDA, 0xF8, 0xD9,
        0x67, 0x0A, 0x12, 0x36, 0x36, 0xB8, 0x49, 0x70, 0x8D, 0xD4, 0x15, 0xDC,
        0x1A, 0x91, 0x4A, 0x56, 0x0B, 0xBA, 0x04, 0x88, 0x49, 0x9F, 0x20, 0x51,
        0xCD, 0x85, 0x75, 0xC7, 0xA2, 0xD8, 0x4B, 0x24, 0xB1, 0xC5, 0xFC, 0x97,
        0x58, 0x7E, 0x9D, 0xE1, 0x2D, 0xD0, 0xAA, 0x34, 0x7C, 0x46, 0xE5, 0x7D,
        0x12, 0x3E, 0xCC, 0xE3, 0xA7, 0xFA, 0x7B, 0x3A, 0x53, 0xC9, 0xAF, 0x9E,
        0x69, 0xB5, 0x8C, 0x25, 0xF0, 0xC4, 0x35, 0x87, 0x36, 0x27, 0x66, 0x79,
        0xDA, 0xCA, 0x97, 0x5D, 0x5B, 0x92, 0xBD, 0x1B, 0xE3, 0x86, 0x47, 0x8B,
        0x96, 0x4D, 0xC3, 0xB7, 0xAF, 0xA7, 0x3E, 0x5C, 0xE1, 0x4E, 0xA1, 0x78,
        0xC6, 0xFD, 0x08, 0x46, 0x80, 0xDB, 0x84, 0xA0, 0xEE, 0x96, 0x34, 0xC9,
        0x61, 0x64, 0x7C, 0xDE, 0xCA, 0xAF, 0xBC, 0x97, 0x39, 0x69, 0x67, 0xA7,
        0xD8, 0x9F, 0xD9, 0x6C, 0x78, 0x7C, 0x1C, 0xEE, 0xC2, 0xFC, 0x75, 0x4B,
        0xB5, 0xDF, 0x1F, 0xC2, 0x6C, 0x32, 0xD5, 0xF3, 0x71, 0x9C, 0x29, 0xBA,
        0xD7, 0x37, 0x90, 0xC4, 0x5F, 0x40, 0x86, 0x31, 0x50, 0x6F, 0xA3, 0xA9,
        0x0C, 0xD2, 0xBF, 0xC3, 0x08, 0x90, 0x7C, 0x73, 0x6C, 0x0E, 0x13, 0x24,
        0xB3, 0xC8, 0x34, 0x27, 0x6D, 0xA3, 0x72, 0x78, 0x74, 0x00, 0x2A, 0xAA,
        0xE6, 0xF9, 0x2D, 0x87, 0x1B, 0xC3, 0xC8, 0xD1, 0xAA, 0x75, 0x11, 0x57,
        0x00, 0x27, 0x69, 0x26, 0x9C, 0x73, 0xE8, 0x07, 0x21, 0x57, 0xFA, 0x28,
        0x3B, 0x57, 0x7C, 0x2D, 0x98, 0x5D, 0x95, 0x77, 0xAE, 0x2D, 0x66, 0x48,
        0x0B, 0xB0, 0xDC, 0x23, 0x7C, 0x34, 0xD7, 0x5A, 0xAA, 0x80, 0x86, 0xED,
        0x05, 0xC4, 0x10, 0xCD, 0x9D, 0x3F, 0xF9, 0xA9, 0x6C, 0x5D, 0x47, 0xC9,
        0xAF, 0x84, 0xA8, 0x16, 0x7B, 0xB7, 0x21, 0xFE};
static const uint8_t ciphertext_GCM_128_256[] = {
        0x03, 0x88, 0xDA, 0xCE, 0x60, 0xB6, 0xA3, 0x92, 0xF3, 0x28, 0xC2,
        0xB9, 0x71, 0xB2, 0xFE, 0x78, 0xF7, 0x95, 0xAA, 0xAB, 0x49, 0x4B,
        0x59, 0x23, 0xF7, 0xFD, 0x89, 0xFF, 0x94, 0x8B, 0xC1, 0xE0};
static const uint8_t ciphertext_GCM_256_256[] = {
        0xCE, 0xA7, 0x40, 0x3D, 0x4D, 0x60, 0x6B, 0x6E, 0x07, 0x4E, 0xC5,
        0xD3, 0xBA, 0xF3, 0x9D, 0x18, 0x72, 0x60, 0x03, 0xCA, 0x37, 0xA6,
        0x2A, 0x74, 0xD1, 0xA2, 0xF5, 0x8E, 0x75, 0x06, 0x35, 0x8E};
static const uint8_t ciphertext_GCM_128_4096[] = {
        0x03, 0x88, 0xDA, 0xCE, 0x60, 0xB6, 0xA3, 0x92, 0xF3, 0x28, 0xC2, 0xB9,
        0x71, 0xB2, 0xFE, 0x78, 0xF7, 0x95, 0xAA, 0xAB, 0x49, 0x4B, 0x59, 0x23,
        0xF7, 0xFD, 0x89, 0xFF, 0x94, 0x8B, 0xC1, 0xE0, 0x20, 0x02, 0x11, 0x21,
        0x4E, 0x73, 0x94, 0xDA, 0x20, 0x89, 0xB6, 0xAC, 0xD0, 0x93, 0xAB, 0xE0,
        0xC9, 0x4D, 0xA2, 0x19, 0x11, 0x8E, 0x29, 0x7D, 0x7B, 0x7E, 0xBC, 0xBC,
        0xC9, 0xC3, 0x88, 0xF2, 0x8A, 0xDE, 0x7D, 0x85, 0xA8, 0xEE, 0x35, 0x61,
        0x6F, 0x71, 0x24, 0xA9, 0xD5, 0x27, 0x02, 0x91, 0x95, 0xB8, 0x4D, 0x1B,
        0x96, 0xC6, 0x90, 0xFF, 0x2F, 0x2D, 0xE3, 0x0B, 0xF2, 0xEC, 0x89, 0xE0,
        0x02, 0x53, 0x78, 0x6E, 0x12, 0x65, 0x04, 0xF0, 0xDA, 0xB9, 0x0C, 0x48,
        0xA3, 0x03, 0x21, 0xDE, 0x33, 0x45, 0xE6, 0xB0, 0x46, 0x1E, 0x7C, 0x9E,
        0x6C, 0x6B, 0x7A, 0xFE, 0xDD, 0xE8, 0x3F, 0x40, 0xDE, 0xB3, 0xFA, 0x67,
        0x94, 0xF8, 0xFD, 0x8F, 0x55, 0xA8, 0x8D, 0xCB, 0xDA, 0x9D, 0x68, 0xF2,
        0x13, 0x7C, 0xC9, 0xC8, 0x34, 0x20, 0x07, 0x7E, 0x7C, 0xF2, 0x8A, 0xB2,
        0x69, 0x6B, 0x0D, 0xF0, 0x5D, 0x11, 0x45, 0x2B, 0x58, 0xAC, 0x50, 0xAA,
        0x2E, 0xB3, 0xA1, 0x95, 0xB6, 0x1B, 0x87, 0xE5, 0xC6, 0x5A, 0x6D, 0xD5,
        0xD7, 0xF7, 0xA8, 0x40, 0x65, 0xD5, 0xA1, 0x7F, 0xF4, 0x62, 0x73, 0x08,
        0x60, 0x02, 0x49, 0x6D, 0xB6, 0x3F, 0xA4, 0xB9, 0x1B, 0xEE, 0x38, 0x7F,
        0xA3, 0x03, 0x0C, 0x95, 0xA7, 0x3F, 0x8D, 0x04, 0x37, 0xE0, 0x91, 0x5F,
        0xBC, 0xE5, 0xD7, 0xA6, 0x2D, 0x8D, 0xAB, 0x0A, 0x58, 0xB2, 0x43, 0x1B,
        0xC0, 0xBE, 0xDE, 0x02, 0x55, 0x0F, 0x40, 0x23, 0x89, 0x69, 0xEC, 0x78,
        0x04, 0x10, 0xBE, 0xFC, 0xCD, 0xE6, 0x94, 0x4B, 0x69, 0xDD, 0x00, 0x7D,
        0xEB, 0xE3, 0x9A, 0x9D, 0xBC, 0x5E, 0x24, 0xF5, 0x19, 0xA4, 0xBD, 0xF4,
        0x78, 0xB1, 0xD9, 0xEC, 0x0B, 0x67, 0x12, 0x5F, 0x28, 0xB0, 0x6E, 0xFA,
        0xA5, 0x5D, 0x79, 0x41, 0x2A, 0xD6, 0x28, 0xD4, 0x50, 0x89, 0xC3, 0xC3,
        0x04, 0xF9, 0x4D, 0xB3, 0xA2, 0x1D, 0xF6, 0xCD, 0xAF, 0x6D, 0x2E, 0x2E,
        0x3B, 0x35, 0x54, 0x41, 0xEF, 0xF6, 0x4A, 0xD9, 0x05, 0x27, 0xE7, 0x52,
        0xA4, 0xB2, 0xEB, 0xB4, 0xD0, 0xA1, 0x07, 0x0C, 0xE2, 0xE2, 0x98, 0x2E,
        0x27, 0x2F, 0xDB, 0x7C, 0xF4, 0xB5, 0x84, 0xB0, 0x95, 0xA0, 0xF9, 0x57,
        0xFD, 0xB8, 0x28, 0x68, 0x94, 0x37, 0xE3, 0x7D, 0xC4, 0x8B, 0x2A, 0xD3,
        0x79, 0xC6, 0xF3, 0xC6, 0xE9, 0x57, 0xEE, 0x77, 0xAF, 0xB8, 0x8C, 0x65,
        0x94, 0x9B, 0xA1, 0x2E, 0xEC, 0x45, 0xC2, 0x28, 0x65, 0xE4, 0x90, 0x7A,
        0xE4, 0x2A, 0xEE, 0x81, 0x38, 0x98, 0xAC, 0xDF, 0x91, 0xE2, 0xE4, 0xC2,
        0x1D, 0x82, 0x8E, 0x0A, 0x76, 0xDE, 0x2B, 0xB6, 0xBB, 0x6F, 0x86, 0x9E,
        0x5E, 0xEF, 0x1F, 0x61, 0x8D, 0xED, 0xD2, 0x75, 0x62, 0x81, 0x2B, 0x9A,
        0x14, 0xE8, 0x99, 0x6A, 0x5C, 0x35, 0x2D, 0xF3, 0x81, 0x7E, 0x60, 0xD6,
        0xEC, 0x20, 0x11, 0x9A, 0x52, 0xC8, 0x0A, 0x61, 0xEC, 0x19, 0x56, 0x22,
        0x62, 0x72, 0x40, 0x21, 0x2D, 0xEC, 0xCA, 0x51, 0x5F, 0xEA, 0xB6, 0x3E,
        0x27, 0x34, 0x58, 0x79, 0x48, 0xA8, 0x36, 0xA7, 0xDE, 0x20, 0x5C, 0xFE,
        0xC0, 0xC2, 0x88, 0x35, 0x1C, 0x34, 0x8B, 0x11, 0x79, 0x41, 0xDD, 0x0A,
        0x63, 0xD9, 0x94, 0x70, 0x3E, 0x63, 0xD9, 0x4A, 0x44, 0x68, 0x04, 0x21,
        0x3A, 0xB4, 0xFB, 0x1D, 0x2B, 0x7B, 0xA3, 0x76, 0x59, 0x0A, 0x2C, 0x24,
        0x1D, 0x1F, 0x50, 0x8D, 0xC6, 0xA7, 0xF4, 0x18, 0xA1, 0x45, 0x03, 0xDE,
        0xB8, 0x9B, 0x17, 0xAA, 0xDB, 0x28, 0x06, 0xF7};
static const uint8_t ciphertext_GCM_256_4096[] = {
        0xCE, 0xA7, 0x40, 0x3D, 0x4D, 0x60, 0x6B, 0x6E, 0x07, 0x4E, 0xC5, 0xD3,
        0xBA, 0xF3, 0x9D, 0x18, 0x72, 0x60, 0x03, 0xCA, 0x37, 0xA6, 0x2A, 0x74,
        0xD1, 0xA2, 0xF5, 0x8E, 0x75, 0x06, 0x35, 0x8E, 0xDD, 0x4A, 0xB1, 0x28,
        0x4D, 0x4A, 0xE1, 0x7B, 0x41, 0xE8, 0x59, 0x24, 0x47, 0x0C, 0x36, 0xF7,
        0x47, 0x41, 0xCB, 0xE1, 0x81, 0xBB, 0x7F, 0x30, 0x61, 0x7C, 0x1D, 0xE3,
        0xAB, 0x0C, 0x3A, 0x1F, 0xD0, 0xC4, 0x8F, 0x73, 0x21, 0xA8, 0x2D, 0x37,
        0x60, 0x95, 0xAC, 0xE0, 0x41, 0x91, 0x67, 0xA0, 0xBC, 0xAF, 0x49, 0xB0,
        0xC0, 0xCE, 0xA6, 0x2D, 0xE6, 0xBC, 0x1C, 0x66, 0x54, 0x5E, 0x1D, 0xAD,
        0xAB, 0xFA, 0x77, 0xCD, 0x6E, 0x85, 0xDA, 0x24, 0x5F, 0xB0, 0xBD, 0xC5,
        0xE5, 0x2C, 0xFC, 0x29, 0xBA, 0x0A, 0xE1, 0xAB, 0x28, 0x37, 0xE0, 0xF3,
        0x63, 0x87, 0xB7, 0x0E, 0x93, 0x17, 0x60, 0x12, 0x43, 0x62, 0xC2, 0xBB,
        0x66, 0xD8, 0xF4, 0xB1, 0x37, 0xFC, 0xE8, 0x34, 0x2C, 0x9C, 0xD3, 0x86,
        0xA1, 0x14, 0x42, 0x96, 0xE2, 0x72, 0x68, 0xA8, 0xE5, 0x0D, 0xF5, 0x37,
        0xA8, 0x05, 0xD5, 0x79, 0xBB, 0x21, 0xEB, 0xBD, 0xF3, 0x57, 0xED, 0x34,
        0xBF, 0x58, 0xB5, 0x83, 0x71, 0x50, 0xDD, 0xCA, 0xF3, 0x62, 0x22, 0x5E,
        0x62, 0x0A, 0x60, 0x70, 0xAC, 0x5E, 0xF5, 0x29, 0xFB, 0x52, 0x24, 0x66,
        0x76, 0x8B, 0x78, 0xC0, 0x4B, 0x54, 0xE5, 0x1E, 0xF5, 0xFA, 0x07, 0xE5,
        0x06, 0xA3, 0x5F, 0xC6, 0xB0, 0xB7, 0x10, 0x24, 0x9C, 0x86, 0x26, 0xE1,
        0xA9, 0x6A, 0xD5, 0x78, 0x28, 0xD7, 0xBE, 0x2E, 0x14, 0x90, 0xA0, 0x5A,
        0x7C, 0xEE, 0x43, 0xBD, 0xE9, 0x8B, 0x56, 0xE3, 0x09, 0xDC, 0x01, 0x26,
        0x4E, 0xD6, 0xDF, 0x6E, 0x82, 0xC1, 0xBF, 0xC7, 0x2A, 0x59, 0xAD, 0x53,
        0xA9, 0xC0, 0xE4, 0x34, 0x7D, 0x6C, 0x52, 0x78, 0x50, 0x79, 0x40, 0xA7,
        0xDE, 0xF6, 0xBA, 0x93, 0xE8, 0xB6, 0xAF, 0x1E, 0x46, 0x53, 0x72, 0x76,
        0x61, 0x1B, 0xC7, 0x66, 0x95, 0x5C, 0x58, 0x7D, 0x30, 0x1B, 0xA8, 0x47,
        0xAC, 0xC9, 0xDD, 0xA7, 0x8A, 0x43, 0x8E, 0x2C, 0x0A, 0x69, 0xD5, 0x14,
        0x74, 0x4C, 0x72, 0xD3, 0x4F, 0x32, 0x6B, 0x9B, 0x7E, 0xF3, 0x42, 0x86,
        0xCA, 0x0E, 0xF8, 0xA7, 0xEA, 0xE0, 0x6E, 0xBE, 0x66, 0x9C, 0x53, 0x72,
        0x12, 0x40, 0x2D, 0xCB, 0x5F, 0xEA, 0xE9, 0x9D, 0x76, 0xC7, 0xF4, 0xA7,
        0x6A, 0xBD, 0xB7, 0x9C, 0x0D, 0xFA, 0xA0, 0x38, 0xA0, 0xE2, 0x28, 0x2C,
        0x73, 0x0E, 0xD4, 0x8B, 0x86, 0x9D, 0xAC, 0x2F, 0x16, 0x8E, 0xCF, 0x3E,
        0xA6, 0x10, 0xE6, 0x1F, 0xAC, 0x51, 0x2C, 0x8E, 0x95, 0xFB, 0x8C, 0x06,
        0xDE, 0x62, 0xBC, 0x76, 0x69, 0x55, 0x51, 0x35, 0x8A, 0xDB, 0x86, 0x4C,
        0xC2, 0x68, 0xF9, 0x14, 0xB4, 0x9A, 0xB3, 0xAA, 0x20, 0xED, 0xFD, 0xB2,
        0xD1, 0x72, 0x79, 0x81, 0x37, 0xB4, 0xB3, 0xD8, 0xDD, 0xD1, 0x75, 0x22,
        0xEB, 0x2C, 0xBF, 0xE4, 0xDC, 0x47, 0xCF, 0x9F, 0xB0, 0xFA, 0x1C, 0xCD,
        0x23, 0xDE, 0xDB, 0x56, 0x93, 0xD1, 0xF5, 0x0A, 0xE4, 0xED, 0xDE, 0xE7,
        0x08, 0x20, 0xB0, 0xF7, 0xC6, 0xE0, 0x73, 0x08, 0x9E, 0x2D, 0x1D, 0xFD,
        0x97, 0xB0, 0x6C, 0x32, 0xA5, 0x00, 0x36, 0xD8, 0x28, 0x4D, 0xBF, 0x34,
        0x68, 0x29, 0x2E, 0xE0, 0xB6, 0x2E, 0xC8, 0x7C, 0x88, 0x7C, 0xB1, 0xEB,
        0x76, 0xB4, 0x67, 0x20, 0x10, 0x41, 0x30, 0xDB, 0xF1, 0x96, 0x63, 0x87,
        0x48, 0x2D, 0xC4, 0x3F, 0x23, 0x88, 0xEF, 0x25, 0xD2, 0x41, 0x44, 0xE1,
        0x44, 0xBD, 0x83, 0x4E, 0x44, 0x8E, 0x7D, 0xA3, 0xBF, 0xA6, 0xEA, 0xF9,
        0xBC, 0xDA, 0x21, 0x5C, 0xBA, 0x50, 0x0C, 0xF3};

/**
 * struct crypto_hwaes_state_t - holds the current bench state.
 * @hwaes_session: handle to an open session with the hwaes secure app.
 * @memref: handle to the shared memory.
 * @shm_base: base address of shared memory.
 * @shm_len: length of shared memory.
 * @shm_hd: packing of the 3 args above to match hwaes_crypt args structure
 * @args:   parameters to the actual encryption routine
 * @req_hdr: request structure for hwaes. Holds the command to be sent
 * @cmd_hdr: request header for HWAES_AES command
 * @shm_descs: yet another packing of shared memory descriptor
 * @req_iov:   iovector array of requests
 * @req_shm:   shared memories array for request
 */
typedef struct {
    hwaes_session_t hwaes_session;
    handle_t memref;
    void* shm_base;
    size_t shm_len;
    struct hwcrypt_shm_hd shm_hd;
    struct hwcrypt_args args;
    struct hwaes_req req_hdr;
    struct hwaes_aes_req cmd_hdr;
    struct hwaes_shm_desc shm_descs[HWAES_MAX_NUM_HANDLES];
    struct hwaes_iov req_iov;
    struct hwaes_shm req_shm;
} crypto_hwaes_state_t;

static crypto_hwaes_state_t* _state;

/**
 * struct crypto_hwaes_param_t - Necessary Parameters for hwaes_encrypt.
 * @key: key to use for encryption
 * @key_size: byte size of the key
 * @input: base address of the bytes blob to be encrypted/decrypted
 * @input_size: size of the bytes blob to be encrypted/decrypted
 * @output: bytes blob resulting from encryption/decryption
 * @output_size: size of the bytes blob resulting from encryption/decryption
 * @iv: initialization vector for encryption/decryption
 * @iv_size: size of the initialization vector for encryption/decryption
 * @tag: expected tag output for GCM encryption
 * @tag_size: size of the expected tag output for GCM encryption
 * @mode: GMC/CBC AES ecnryption block mode
 * @encrypt: direction? encrypt or decrypt
 */
typedef struct crypto_hwaes_param_t {
    const uint8_t* key;
    size_t key_size;
    const uint8_t* input;
    size_t input_size;
    const uint8_t* output;
    size_t output_size;
    const uint8_t* iv;
    size_t iv_size;
    const uint8_t* tag;
    size_t tag_size;
    enum hwaes_mode mode;
    bool encrypt;
} crypto_hwaes_param_t;

/**
 * Array of parameters for the parametric BENCH
 */
static crypto_hwaes_param_t params[16] = {
        HWAES_CRYPT_ARGS(CBC, 128, 256, ENCRYPT),
        HWAES_CRYPT_ARGS(CBC, 128, 256, DECRYPT),
        HWAES_CRYPT_ARGS(CBC, 128, 4096, ENCRYPT),
        HWAES_CRYPT_ARGS(CBC, 128, 4096, DECRYPT),
        HWAES_CRYPT_ARGS(CBC, 256, 256, ENCRYPT),
        HWAES_CRYPT_ARGS(CBC, 256, 256, DECRYPT),
        HWAES_CRYPT_ARGS(CBC, 256, 4096, ENCRYPT),
        HWAES_CRYPT_ARGS(CBC, 256, 4096, DECRYPT),
        HWAES_CRYPT_ARGS(GCM, 128, 256, ENCRYPT),
        HWAES_CRYPT_ARGS(GCM, 128, 256, DECRYPT),
        HWAES_CRYPT_ARGS(GCM, 128, 4096, ENCRYPT),
        HWAES_CRYPT_ARGS(GCM, 128, 4096, DECRYPT),
        HWAES_CRYPT_ARGS(GCM, 256, 256, ENCRYPT),
        HWAES_CRYPT_ARGS(GCM, 256, 256, DECRYPT),
        HWAES_CRYPT_ARGS(GCM, 256, 4096, ENCRYPT),
        HWAES_CRYPT_ARGS(GCM, 256, 4096, DECRYPT),
};

static void get_param_name_cb(char* buf, size_t buf_size, size_t param_idx) {
    snprintf(buf, buf_size, "%s%sK%zu_%zu",
             params[param_idx].encrypt ? "ENC_" : "DEC_",
             params[param_idx].mode == HWAES_CBC_MODE ? "CBC_" : "GCM_",
             params[param_idx].key_size * 8, params[param_idx].input_size * 8);
}

BENCH_SETUP(crypto) {
    int rc = NO_ERROR;
    trusty_bench_get_param_name_cb = &get_param_name_cb;

    /*
     * Create State Container for next bench run
     */
    _state = malloc(sizeof(crypto_hwaes_state_t));
    if (_state == NULL) {
        TLOGE("Cannot Allocate Memory for _state.\n");
        rc = ERR_NO_MEMORY;
        /* jump to abort and test framework bookkeeping*/
        ASSERT_EQ(rc, NO_ERROR);
    }

    /*
     * Make sure we get all the memory we need
     */
    void* shm_base;
    size_t shm_len = PAGE_SIZE();
    shm_base = memalign(PAGE_SIZE(), shm_len);
    if (shm_base == NULL) {
        TLOGE("Failed to allocate shared memory.\n");
        rc = ERR_NO_MEMORY;
        /* jump to abort and test framework bookkeeping*/
        ASSERT_EQ(rc, NO_ERROR);
    }
    _state->memref =
            (handle_t)memref_create(shm_base, shm_len, PROT_READ | PROT_WRITE);
    if (_state->memref < 0) {
        TLOGE("Failed to create reference to shared memory.\n");
        rc = ERR_BAD_HANDLE;
        /* jump to abort and test framework bookkeeping*/
        ASSERT_EQ(rc, NO_ERROR);
    }
    _state->shm_base = shm_base;
    _state->shm_len = shm_len;

    /*
     * Clear the shared memory and fill it with appropriate plaintext/ciphertext
     */
    memset(_state->shm_base, 0, _state->shm_len);
    ASSERT_GE(_state->shm_len, CUR_PARAM.input_size);

    memcpy(_state->shm_base, CUR_PARAM.input, CUR_PARAM.input_size);

    /*
     * Setup the allocated state and open session with hwaes trusted app server
     */
    _state->hwaes_session = INVALID_IPC_HANDLE;
    rc = hwaes_open(&_state->hwaes_session);
    if (rc != NO_ERROR) {
        TLOGE("Could not open HWAES Session.\n");
        /* jump to abort and test framework bookkeeping */
        ASSERT_EQ(rc, NO_ERROR);
    }

    /*
     * Pack the Shared Memory Handle.
     */
    _state->shm_hd = (struct hwcrypt_shm_hd){
            .handle = _state->memref,
            .base = _state->shm_base,
            .size = _state->shm_len,
    };

    /*
     * Pack the required arguments for hwaes_encrypt/hwaes_decrypt.
     */
    _state->args = (struct hwcrypt_args){
            .key =
                    {
                            .data_ptr = CUR_PARAM.key,
                            .len = CUR_PARAM.key_size,
                    },
            .iv =
                    {
                            .data_ptr = CUR_PARAM.iv,
                            .len = CUR_PARAM.iv_size,
                    },
            .text_in =
                    {
                            .data_ptr = _state->shm_base,
                            .len = CUR_PARAM.input_size,
                            .shm_hd_ptr = &_state->shm_hd,
                    },
            .text_out =
                    {
                            .data_ptr = _state->shm_base,
                            .len = CUR_PARAM.output_size,
                            .shm_hd_ptr = &_state->shm_hd,
                    },
            .key_type = HWAES_PLAINTEXT_KEY,
            .padding = HWAES_NO_PADDING,
            .mode = CUR_PARAM.mode,
    };

    /*
     * Prepare the command for hwaes server app.
     */
    _state->req_hdr = (struct hwaes_req){
            .cmd = HWAES_AES,
    };
    _state->cmd_hdr = (struct hwaes_aes_req){
            .key =
                    (struct hwaes_data_desc){
                            .len = CUR_PARAM.key_size,
                            .shm_idx = 0,
                    },
            .num_handles = 1,
    };
    _state->shm_descs[0] = (struct hwaes_shm_desc){.size = _state->shm_len};
    _state->req_iov = (struct hwaes_iov){
            .iov =
                    {
                            {&_state->req_hdr, sizeof(_state->req_hdr)},
                            {&_state->cmd_hdr, sizeof(_state->cmd_hdr)},
                            {&_state->shm_descs, sizeof(struct hwaes_shm_desc)},
                    },
            .num_iov = 3,
            .total_len = sizeof(_state->req_hdr) + sizeof(_state->cmd_hdr) +
                         sizeof(struct hwaes_shm_desc),
    };
    _state->req_shm = (struct hwaes_shm){
            .handles = {_state->memref},
            .num_handles = 1,
    };

    /**
     * Setup input and expected output (text_in/text_out)
     * Setup GCM specifics (tag and aad)
     */
    _state->args.text_out.len = CUR_PARAM.input_size;
    _state->args.text_in.len = CUR_PARAM.input_size;

    if (CUR_PARAM.mode == HWAES_GCM_MODE) {
        _state->args.aad.data_ptr = aad;
        _state->args.aad.len = sizeof(aad);

        if (CUR_PARAM.encrypt) {
            /* clang-format off */
            _state->args.text_out.data_ptr          = _state->shm_base;
            _state->args.text_out.shm_hd_ptr        = &_state->shm_hd;

            _state->args.tag_out.len                = GCM_TAG_LEN;
            ASSERT_GE(_state->shm_len, _state->args.text_out.len + _state->args.tag_out.len);
            _state->args.tag_out.data_ptr           = _state->shm_base + _state->args.text_out.len;
            _state->args.tag_out.shm_hd_ptr         = &_state->shm_hd;
            /* clang-format on */
        } else {
            _state->args.tag_in.len = GCM_TAG_LEN;
            _state->args.tag_in.data_ptr = CUR_PARAM.tag;
        }
    }
    rc = NO_ERROR;
    return rc;
test_abort:
    TLOGE("ERROR SETUP ABORTED\n");
    return rc;
}

BENCH_TEARDOWN(crypto) {
    close(_state->hwaes_session);
    close(_state->memref);
    free(_state->shm_base);
    free(_state);
}

static int encrypt() {
    int rc = hwaes_encrypt(_state->hwaes_session, &_state->args);
    ASSERT_EQ(HWAES_NO_ERROR, rc, "encryption failed for param: %zu\n",
              bench_get_param_idx());
    rc = memcmp(_state->shm_base, CUR_PARAM.output, CUR_PARAM.input_size);
    ASSERT_EQ(NO_ERROR, rc, "wrong encryption result for param: %zu\n",
              bench_get_param_idx());
test_abort:
    return rc;
}

static int decrypt() {
    int rc = HWAES_NO_ERROR;
    rc = hwaes_decrypt(_state->hwaes_session, &_state->args);

    ASSERT_EQ(HWAES_NO_ERROR, rc, "decryption failed for param: %zu\n",
              bench_get_param_idx());
    rc = memcmp(_state->shm_base, plaintext, CUR_PARAM.input_size);
    ASSERT_EQ(0, rc, "wrong decryption result for param: %zu\n",
              bench_get_param_idx());

test_abort:
    return rc;
}

/* Function to benchmark, call 1 run */
BENCH(crypto, hwaes, 1, params) {
    if (CUR_PARAM.encrypt) {
        return encrypt();

    } else {
        return decrypt();
    }
}

BENCH_RESULT(crypto, hwaes, ns_per_byte) {
    return bench_get_duration_ns() / CUR_PARAM.input_size;
}

PORT_TEST(hwaes, "com.android.trusty.hwaes.bench")
